Index: /trunk/sources/HeuristicLab.Clients.Common/3.3/ClientFactory.cs
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Common/3.3/ClientFactory.cs	(revision 5705)
+++ /trunk/sources/HeuristicLab.Clients.Common/3.3/ClientFactory.cs	(revision 5706)
@@ -24,5 +24,4 @@
 using System.ServiceModel.Description;
 using HeuristicLab.Clients.Common.Properties;
-using HeuristicLab.Common;
 
 namespace HeuristicLab.Clients.Common {
@@ -66,44 +65,25 @@
 
     #region CreateChannelFactory Methods
-    public static Disposable<ChannelFactory<I>> CreateChannelFactory<I>(string endpointConfigurationName)
+    public static ChannelFactory<I> CreateChannelFactory<I>(string endpointConfigurationName)
       where I : class {
       return CreateChannelFactory<I>(endpointConfigurationName, null);
     }
-    public static Disposable<ChannelFactory<I>> CreateChannelFactory<I>(string endpointConfigurationName, string remoteAddress)
+    public static ChannelFactory<I> CreateChannelFactory<I>(string endpointConfigurationName, string remoteAddress)
       where I : class {
       return CreateChannelFactory<I>(endpointConfigurationName, remoteAddress, Settings.Default.UserName, Settings.Default.Password);
     }
-    public static Disposable<ChannelFactory<I>> CreateChannelFactory<I>(string endpointConfigurationName, string remoteAddress, string userName, string password)
+    public static ChannelFactory<I> CreateChannelFactory<I>(string endpointConfigurationName, string remoteAddress, string userName, string password)
       where I : class {
       ChannelFactory<I> channelFactory = new ChannelFactory<I>(endpointConfigurationName);
-      channelFactory.Credentials.UserName.UserName = userName;
-      channelFactory.Credentials.UserName.Password = password;
-      channelFactory.Credentials.ServiceCertificate.Authentication.CertificateValidationMode = System.ServiceModel.Security.X509CertificateValidationMode.None;
-
       if (!string.IsNullOrEmpty(remoteAddress)) {
         SetEndpointAddress(channelFactory.Endpoint, remoteAddress);
       }
 
-      Disposable<ChannelFactory<I>> disposableChannelFactory = new Disposable<ChannelFactory<I>>(channelFactory);
-      disposableChannelFactory.OnDisposing += new EventHandler<EventArgs<object>>(DisposableChannelFactory_OnDisposing);
-      return disposableChannelFactory;
-    }
-
-    private static void DisposableChannelFactory_OnDisposing(object sender, EventArgs<object> e) {
-      DisposeCommunicationObject((ICommunicationObject)e.Value);
-      ((Disposable)sender).OnDisposing -= new EventHandler<EventArgs<object>>(DisposableChannelFactory_OnDisposing);
+      channelFactory.Credentials.UserName.UserName = userName;
+      channelFactory.Credentials.UserName.Password = password;
+      channelFactory.Credentials.ServiceCertificate.Authentication.CertificateValidationMode = System.ServiceModel.Security.X509CertificateValidationMode.None;
+      return channelFactory;
     }
     #endregion
-
-    public static void DisposeCommunicationObject(ICommunicationObject obj) {
-      if (obj != null) {
-        if (obj.State != CommunicationState.Faulted && obj.State != CommunicationState.Closed) {
-          try { obj.Close(); }
-          catch { obj.Abort(); }
-        } else {
-          obj.Abort();
-        }
-      }
-    }
 
     #region Helpers
Index: unk/sources/HeuristicLab.Clients.Common/3.3/Disposable.cs
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Common/3.3/Disposable.cs	(revision 5705)
+++ 	(revision )
@@ -1,51 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using HeuristicLab.Common;
-
-namespace HeuristicLab.Clients.Common {
-  public class Disposable : IDisposable {
-    protected object obj;
-    public object Obj {
-      get { return obj; }
-    }
-
-    public Disposable(object obj) {
-      this.obj = obj;
-    }
-
-    public void Dispose() {
-      if (OnDisposing != null)
-        OnDisposing(this, new EventArgs<object>(obj));
-    }
-
-    public event EventHandler<EventArgs<object>> OnDisposing;
-  }
-
-  public sealed class Disposable<T> : Disposable {
-    public new T Obj {
-      get { return (T)base.obj; }
-    }
-
-    public Disposable(T obj) : base(obj) { }
-  }
-}
Index: /trunk/sources/HeuristicLab.Clients.Common/3.3/HeuristicLab.Clients.Common-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Common/3.3/HeuristicLab.Clients.Common-3.3.csproj	(revision 5705)
+++ /trunk/sources/HeuristicLab.Clients.Common/3.3/HeuristicLab.Clients.Common-3.3.csproj	(revision 5706)
@@ -12,5 +12,6 @@
     <AssemblyName>HeuristicLab.Clients.Common-3.3</AssemblyName>
     <TargetFrameworkVersion>v4.0</TargetFrameworkVersion>
-    <TargetFrameworkProfile></TargetFrameworkProfile>
+    <TargetFrameworkProfile>
+    </TargetFrameworkProfile>
     <FileAlignment>512</FileAlignment>
     <TargetFrameworkProfile />
@@ -116,5 +117,4 @@
   <ItemGroup>
     <Compile Include="ClientFactory.cs" />
-    <Compile Include="Disposable.cs" />
     <Compile Include="HeuristicLabClientsCommonPlugin.cs" />
     <Compile Include="PasswordDialog.cs">